{
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
   eXtreme Class Library
   of classes to replace
   Delphi VCL. Non-visual object oriented Pascal programming
   for Windows. XCL allow creating of very small applets
   which therefore can look like usual Windows applications.

   Idea: Kladov Vladimir (C) 1999, bonanzas@online.sinor.ru
   Home: http://members.xoom.com/mr_bonanzas
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
   XCL Wizard tool by Vladimir Kladov (C) 1999
   intended to provide XCL with its own visual
   programming environment. It is including
   following parts:
   - XCL Expert, integrated into IDE and providing
                 XCL Designer with notifications about
                 IDE events and executing its requests
   - XCL Designer, interacting with XCL Expert part
                 and containing:
                 - XCL Forms Visual Editor
                 - XCL Property Inspector
                 - XCL Classes Palette
   - XCL Library (DLL), containing all XCL classes
                 compiled and defined in special format
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
   Here is XCL Library interface unit, which is listed
   in 'uses' clause of the DLL itself and in Designer
   part too. Changing this file cause to recompile both
   DLL and XCL Designer parts.
}
unit XCLClsLib;

interface

{$INCLUDE XCLDEBUG.INC}

uses ShareMem,
  Windows, XClasses, XWindows, XDsgnControls, XApplets;

const
  XCL = 'XCLCLSD4.dll';

type
  TEditStyles = ( esEdit, esCombo, esChkCombo, esIncDec, esEvent,
                  esBool, esCustom, esConfirm );
  TEditStyle = Set of TEditStyles;

const
  esComboEdit = [ esEdit, esCombo ];
  esNumEdit   = [ esEdit, esIncDec ];
  esBoolEdit  = [ esBool ];
  esCase      = [ esCombo, esIncDec ];

type
  TGetPropAsString = function( Value : DWORD ) : String;
  TString2Prop = function( const StrValue : String ) : DWORD;

  TXFlagArray = array[0..10000] of DWORD;
  PXFlagArray = ^TXFlagArray;

  TEditPropertyProc = procedure( var StrValue : String
              // may be more?
              );

  TGetIntValue = function : Integer;
  TGetStrIdxVal = function( Idx : Integer ) : String;

  PXPropInfo = ^TXPropInfo;
  TXPropInfo = Packed Record // see detailed definitions in XLib.pas
    Nam: PChar;
    Typ: PChar;
    Flg: PXFlagArray;
    Eds: TEditStyle;
    Editor : TEditPropertyProc;
    AsStr: TGetPropAsString;
    SetStr: TString2Prop;
    DesignProtect : Boolean;
    SetAfter: Boolean;
    GetValCount : TGetIntValue;
    GetVal : TGetStrIdxVal;
  end;

  TXPropArray = array[0..10000] of TXPropInfo;
  PXPropArray = ^TXPropArray;

  TAddonUsage = ( auPossible, auDesired, auMust, auNever );
  TXAddonInfo = Packed Record
    ACall : PChar;
    AUnit : PChar;
    Usage : TAddonUsage;
    Descr : PChar;
  end;

  TXAddonArray = array[0..10000] of TXAddonInfo;
  PXAddonArray = ^TXAddonArray;

  TXStringArray = array[0..10000] of PChar;
  PXStringArray = ^TXStringArray;

  TXClassKind = ( ckForm, ckControl, ckChild, ckObject, ckBase, ckApplet );
  TParentProc = function( Sender : TObject ) : TObject;
  TDsgnActive = function( Sender : TObject ) : Boolean;

  TXCreateProc = procedure( Self_ : TObject; Name : PChar );

  TEditClassProc = procedure( Self_ : TObject; Name : PChar
                 // may be more ?
                 );

  PXClassInfo = ^TXClassInfo;
  TXClassInfo = packed record // see filed definitions in XLib.pas
    Page : PChar;
    Name : PChar;
    CTyp : TClass;
    Kind : TXClassKind;
    CUnit: PChar;
    Ancestor  : Integer; //PChar;
    Props : PXPropArray;
    Parent: TParentProc;
    DsgnActive : TDsgnActive;
    Dflts : PXStringArray;
    Editor : TEditClassProc;
    CreateProc : TXCreateProc;
    Addons: PXAddonArray;
  end;

type
  TStringArray = array[ 0..10000 ] of PChar;
  PStringArray = ^TStringArray;

{$IFNDEF INCXLIB}
function CreateForm( Visible : Boolean; Caption : PChar; Rect : PRect; ClsStyle, Style, ExStyle : DWORD;
                     Flags : DWORD; CloseEvnt : XOnEventAccept;
                     ActivateEvnt, SelectEvnt, DeselectEvnt, ResizeEvnt, MoveEvnt : XOnEvent;
                     ClickEvent : XOnDsgnClick; KeyDownEvent, KeyUpEvent : XOnDsgnKey )
                     : TObject;
function CreateFormWindow( Form : TObject ) : HWnd;
function CreateNonvisual( FormObj : TObject; Visible : Boolean; ImgList : THandle; ImgIdx : Integer;
                     Pos : TPoint ) : TObject;
function GetNonvisualWindow( NonVisual : TObject ) : HWnd;
procedure SetNonVisualIcon( NonVisual : TObject; ImgList : THandle;
                            ImgIdx : Integer );

function CheckDesignerVersion( DesignerVersion : Word ) : Boolean;
function GetXLibVersion : Word;
procedure InitInterface( MainInst : HInst; MainApplet : XApplet );
procedure Uninstall;

function GetFormReservedNames : PStringArray;

function GetClassesCount: Integer;
function GetClassInfo(Idx: Integer): PXClassInfo;
function GetCreatorString( AObject : TObject; ClsIdx: Integer ) : string;
function GetPropertyValue(AObject: TObject; ClassIdx, PropIdx: Integer): DWORD;
procedure SetPropertyValue(AObject: TObject; ClassIdx, PropIdx: Integer;Value: DWORD);
function NewClassObject( ClsIdx: Integer; Parent : TObject ) : TObject;
procedure SetFormObjectPos( Obj : TObject; Pos : TPoint );
procedure SelectObject( Form : TObject; Obj : TObject );
procedure DeselectObject( Form : TObject; Obj : TObject );
{$ENDIF}

implementation

{$IFNDEF INCXLIB}

function CreateForm;          external XCL name 'CreateForm';
function CreateFormWindow;    external XCL name 'CreateFormWindow';
function CreateNonvisual;     external XCL name 'CreateNonvisual';
function GetNonvisualWindow;  external XCL name 'GetNonVisualWindow';
procedure SetNonVisualIcon;   external XCL name 'SetNonVisualIcon';

function CheckDesignerVersion;external XCL name 'CheckDesignerVersion';
function GetXLibVersion;      external XCL name 'GetXLibVersion';
procedure InitInterface;      external XCL name 'InitInterface';
procedure UnInstall;          external XCL name 'UnInstall';

function GetFormReservedNames;external XCL name 'GetFormReservedNames';
function GetClassesCount;     external XCL name 'GetClassesCount';
function GetClassInfo;        external XCL name 'GetClassInfo';
function NewClassObject;      external XCL name 'NewClassObject';
function GetCreatorString;    external XCL name 'GetCreatorString';
function GetPropertyValue;    external XCL name 'GetPropertyValue';
procedure SetPropertyValue;   external XCL name 'SetPropertyValue';
procedure SetFormObjectPos;   external XCL name 'SetFormObjectPos';
procedure SelectObject;       external XCL name 'SelectObject';
procedure DeselectObject;     external XCL name 'DeselectObject';
{$ENDIF}

end.
